 /*
  * Copyright (C), 2018-2021
  * Project: starter
  * FileName: DateFormatItems
  * Author:   Louis
  * Date:     2021/11/15 10:11
  */
 package com.eco.plugin.zgtpbxdate.items;

 import com.fr.design.designer.properties.items.Item;
 import com.fr.design.designer.properties.items.ItemProvider;
 import com.fr.design.i18n.Toolkit;

 /**
  * <Function Description><br>
  * <DateFormatItems>
  *
  * @author wink
  * @since 1.0.0
  */
 public class DateFormatItems implements ItemProvider {
     public static final String DATE = "date";
     public static final String YEAR = "year";
     public static final String MONTH = "month";
     public static final String DATES = "dates";
     public static final String WEEK = "week";
     public static final String DATERANGE = "daterange";
     public static final String DATERANGEWEEK = "daterangeweek";
     public static final String DATERANGEMONTH = "daterangemonth";
     public static final String DATETIME = "datetime";
     public static final String DATETIMERANGE = "datetimerange";
     public static Item[] DATE_ITEMS = new Item[]{
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_Year"), YEAR),
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_Month"), MONTH),
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_Date"), DATE),
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_Dates"), DATES),
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_Week"), WEEK),
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_DateRange"), DATERANGE),
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_DateRangeWeek"), DATERANGEWEEK),
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_DateRangeMonth"), DATERANGEMONTH),
//             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_DateTime"), "datetime"),
//             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_DateTimeRange"), "datetimerange"),
//             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_DateRange"), "daterange"),
     };
     public static Item[] TIME_ITEMS = new Item[]{
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_DateTime"), DATETIME),
             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_DateTimeRange"), DATETIMERANGE),
//             new Item(Toolkit.i18nText("Plugin-abege-Date_Format_DateRange"), "daterange"),
     };

     public DateFormatItems() {
     }

     @Override
     public Item[] getItems() {
         return DATE_ITEMS;
     }
 }