package com.eco.plugin.zgtpbxdate.pane.self;

import com.fr.design.ExtraDesignClassManager;
import com.fr.design.beans.ErrorMsgTextFieldAdapter;
import com.fr.design.beans.UITextFieldAdapter;
import com.fr.design.designer.creator.*;
import com.fr.design.foldablepane.UIExpandablePane;
import com.fr.design.fun.TextFieldAdapterProvider;
import com.fr.design.gui.icheckbox.UICheckBox;
import com.fr.design.gui.ilable.UILabel;
import com.fr.design.gui.itextfield.UITextField;
import com.fr.design.i18n.Toolkit;
import com.fr.design.layout.FRGUIPaneFactory;
import com.fr.design.layout.TableLayoutHelper;
import com.fr.design.widget.ui.designer.AbstractDataModify;
import com.fr.design.widget.ui.designer.component.FontSizeComboPane;
import com.fr.form.ui.FieldEditor;
import com.fr.log.FineLoggerFactory;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public abstract class FieldEditorDefinePane<T extends FieldEditor> extends AbstractDataModify<T> {
    protected UICheckBox allowBlankCheckBox;
    protected ErrorMsgTextFieldAdapter errorMsgTextField;
    protected JPanel validatePane;
    protected FontSizeComboPane fontSizePane;
    protected UITextField labelNameTextField;

    public FieldEditorDefinePane(XCreator var1) {
        super(var1);
        this.initComponents();
    }

    protected void initComponents() {
        this.setLayout(FRGUIPaneFactory.createBorderLayout());
        this.labelNameTextField = new UITextField();
        this.allowBlankCheckBox = new UICheckBox(Toolkit.i18nText("Fine-Design_Form_Allow_Null"));
        this.allowBlankCheckBox.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
        this.fontSizePane = new FontSizeComboPane();
        JPanel var1 = this.setFirstContentPane();

        if (var1 != null) {
            JPanel var2 = FRGUIPaneFactory.createBorderLayout_S_Pane();
            var2.add(var1, "Center");
            var1.setBorder(BorderFactory.createEmptyBorder(10, 0, 10, 0));
            UIExpandablePane var3 = new UIExpandablePane(Toolkit.i18nText("Fine-Design_Report_Advanced"), 280, 20, var2);
            this.add(var3, "North");
        }

//        this.addValidatePane();
    }

    public void populateBean(T var1) {
        this.allowBlankCheckBox.setSelected(var1.isAllowBlank());
//        this.errorMsgTextField.setText(var1.getErrorMessage());
        this.fontSizePane.setValue(var1.getFontSize());
        this.labelNameTextField.setText(var1.getLabelName());
        this.populateSubFieldEditorBean(var1);
    }

    protected abstract void populateSubFieldEditorBean(T var1);

    public T updateBean() {
        FieldEditor var1 = this.updateSubFieldEditorBean();
        var1.setAllowBlank(this.allowBlankCheckBox.isSelected());
//        var1.setErrorMessage(this.errorMsgTextField.getText());
        var1.setFontSize(this.fontSizePane.getValue());
        var1.setLabelName(this.labelNameTextField.getText());
        return (T) var1;
    }

    protected void initErrorMsgPane() {
        TextFieldAdapterProvider var1 = (TextFieldAdapterProvider)ExtraDesignClassManager.getInstance().getSingle("TextFieldAdapterProvider");
        if (var1 == null) {
            this.errorMsgTextField = new UITextFieldAdapter();
        } else {
            try {
                this.errorMsgTextField = var1.createTextFieldAdapter();
            } catch (Exception var3) {
                FineLoggerFactory.getLogger().error(var3.getMessage(), var3);
                this.errorMsgTextField = new UITextFieldAdapter();
            }

        }
    }

    protected abstract T updateSubFieldEditorBean();

    protected abstract JPanel setFirstContentPane();

    public void checkValid() throws Exception {
    }

    protected void addValidatePane() {
        this.initErrorMsgPane();
        this.validatePane = FRGUIPaneFactory.createBorderLayout_S_Pane();
        UILabel var1 = new UILabel(Toolkit.i18nText("Fine-Design_Basic_Widget_Error_Tip"));
        JPanel var2 = FRGUIPaneFactory.createBorderLayout_S_Pane();
        final JPanel var3 = TableLayoutHelper.createGapTableLayoutPane(new Component[][]{{var1, this.errorMsgTextField.getErrorMsgTextField()}}, 1, 10.0D, 6.0D);
        var3.setBorder(BorderFactory.createEmptyBorder(5, 12, 0, 0));
        var2.add(var3, "Center");
        this.allowBlankCheckBox.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent var1) {
                boolean var2 = FieldEditorDefinePane.this.allowBlankCheckBox.isSelected();
                var3.setVisible(!var2);
            }
        });
        Component[][] var4 = new Component[][]{{this.allowBlankCheckBox}, {var2}};
        JPanel var5 = TableLayoutHelper.createGapTableLayoutPane(var4, 1, 5.0D, 0.0D);
        var5.setBorder(BorderFactory.createEmptyBorder(10, 0, 10, 0));
        this.validatePane.add(var5, "North");
        JPanel var6 = this.setValidatePane();
        if (var6 != null) {
            this.validatePane.add(var6, "Center");
        }

        UIExpandablePane var7 = new UIExpandablePane(Toolkit.i18nText("Fine-Design_Basic_Validate"), 280, 20, this.validatePane);
        this.add(var7, "Center");
    }

    public XLayoutContainer getParent(XCreator var1) {
        XLayoutContainer var2 = XCreatorUtils.getParentXLayoutContainer(var1);
        if (var1.acceptType(new Class[]{XWFitLayout.class}) || var1.acceptType(new Class[]{XWParameterLayout.class})) {
            var2 = null;
        }

        return var2;
    }

    public JPanel setValidatePane() {
        return null;
    }
}
