// 计算某个日期距离今天有多少天
function calculateDays(date) {
    const today = new Date(); // 获取今天的日期
    const inputDate = new Date(date); // 将传入的日期字符串转换为日期对象
    // 将日期转换为时间戳，并计算日期差距的毫秒数
    const diff = inputDate.getTime() - today.getTime();
    // 将毫秒数转换为天数差距
    const days = Math.floor(diff / (1000 * 60 * 60 * 24));
    return days + 1;
}
//获取去年第一天到现在一共多少天
function lastYearFToToday(){
    var now = new Date();
    var lastYear = now.getFullYear() - 1;
    var firstDayLastYear = new Date(lastYear, 0, 1);
    var diff = Math.floor((now - firstDayLastYear) / (1000 * 60 * 60 * 24));
    return diff
}
//获取年初到现在一共多少天
function lastYearLToToday(){
    // 获取当前时间的年份
    var currentYear = new Date().getFullYear();
    // 构造去年最后一天的日期
    var lastDayOfLastYear = new Date(currentYear - 1, 11, 31); // 11表示12月，因为月份是从0开始的
    // 计算去年最后一天距离现在的天数
    var timeDiff = new Date() - lastDayOfLastYear;
    var daysDiff = Math.floor(timeDiff / (1000 * 60 * 60 * 24));
    return daysDiff
}

//获取当前时间距离明年第一天还有多少天
function toDayToNextYear(){
    // 获取当前日期
    var currentDate = new Date();
    // 获取明年第一天的日期
    var nextYear = currentDate.getFullYear() + 1;
    var firstDayOfYear = new Date(nextYear, 0, 1);
    // 计算当前时间距离明年第一天的时间差（以天为单位）
    var timeDifference = Math.ceil((firstDayOfYear - currentDate) / (1000 * 60 * 60 * 24));
    return timeDifference - 1
}

//获取上个季度第一天的具体日期
function getLastQuarterFirstDay() {
    var today = new Date(); // 获取当前日期
    var year = today.getFullYear(); // 获取当前年份
    var month = today.getMonth(); // 获取当前月份

    // 计算前一个季度的月份范围
    var startMonth, endMonth;
    if(month >= 0 && month <= 2) { // 第一季度
        startMonth = 9; // 上一年的10月
        endMonth = 11; // 上一年的12月
        year--; // 年份减1
    } else if(month >= 3 && month <= 5) { // 第二季度
        startMonth = 0; // 1月
        endMonth = 2; // 3月
    } else if(month >= 6 && month <= 8) { // 第三季度
        startMonth = 3; // 4月
        endMonth = 5; // 6月
    } else { // 第四季度
        startMonth = 6; // 7月
        endMonth = 8; // 9月
    }

    // 创建日期对象
    var firstDay = new Date(year, startMonth, 1);
    return firstDay.toLocaleDateString();
}


//获取上个季度最后一天距离今天有多少天
function getDaysToLastDayOfPreviousQuarter() {
    var today = new Date();
    var currentMonth = today.getMonth();
    var currentQuarter = Math.floor(currentMonth / 3); // 获取当前季度
    var lastQuarterLastMonth = (currentQuarter - 1) * 3 + 2; // 上个季度的最后一个月
    var lastQuarterLastDay = new Date(today.getFullYear(), lastQuarterLastMonth + 1, 0).getDate(); // 上个季度的最后一天

    var timeDiff = Math.ceil((today - new Date(today.getFullYear(), lastQuarterLastMonth, lastQuarterLastDay)) / (1000 * 60 * 60 * 24));
    return timeDiff
}

//js获取本季度最后一天距离今天有多少天
function getDaysToThisDayOfPreviousQuarter() {
    const currentDate = new Date();
    const currentMonth = currentDate.getMonth() + 1; // 注意月份范围是0-11，所以需要+1
    const currentYear = currentDate.getFullYear();
    let lastDay;

    if (currentMonth >= 1 && currentMonth <= 3) {
        // 第一季度
        lastDay = new Date(currentYear, 2, 31); // 本季度最后一天为3月的31号
    } else if (currentMonth >= 4 && currentMonth <= 6) {
        // 第二季度
        lastDay = new Date(currentYear, 5, 30); // 本季度最后一天为6月的30号
    } else if (currentMonth >= 7 && currentMonth <= 9) {
        // 第三季度
        lastDay = new Date(currentYear, 8, 30); // 本季度最后一天为9月的30号
    } else if (currentMonth >= 10 && currentMonth <= 12) {
        // 第四季度
        lastDay = new Date(currentYear, 11, 31); // 本季度最后一天为12月的31号
    }

    const year = lastDay.getFullYear();
    const month = lastDay.getMonth() + 1;
    const day = lastDay.getDate();

    return `${year}/${month}/${day}`;
}

//上月第一天距离今天
function getLastMonthToToday() {
    // 获取今天的日期
    var today = new Date();
    // 获取上个月的年份和月份
    var year, month;
    if (today.getMonth() === 0) {
        year = today.getFullYear() - 1;
        month = 12;
    } else {
        year = today.getFullYear();
        month = today.getMonth();
    }
    // 构建上个月第一天的日期对象
    var firstDayOfLastMonth = new Date(year, month - 1, 1);
    // 计算上个月第一天距离今天的天数
    var daysDiff = Math.ceil((today - firstDayOfLastMonth) / (1000 * 60 * 60 * 24));
    return daysDiff
}
function getDaysFromFirstDayOfMonth() {
    var today = new Date(); // 获取当前日期
    var firstDay = new Date(today.getFullYear(), today.getMonth(), 1); // 获取本月第一天
    var timeDiff = today.getTime() - firstDay.getTime(); // 计算时间差
    var dayDiff = Math.ceil(timeDiff / (1000 * 3600 * 24)); // 将时间差转换为天数
    return dayDiff;
}

//获取本月最后一天距离今天有多少天
function getDaysUntilLastDayOfMonth() {
    // 获取当前日期
    var today = new Date();
    var lastDayOfMonth = new Date(today.getFullYear(), today.getMonth()+1, 0);
    var diff = lastDayOfMonth.getDate() - today.getDate();
    return diff;
}

//修改左边快捷键的样式
function changeUI(index = 0){ //多个日期组件同时存在一个页面时，改变这个值切换要修改哪个日期的快捷键
    e = window.event||e;
    var obj = e.srcElement || e.target;

    if($(obj).is(".c-datepicker-range-separator")){
        return ;
    }

    let pickers = $(".c-datepicker-popper")
    let id = "changeUi"+index;
    pickers[index].id = id;
    $(`#${id} .c-datepicker-picker__sidebar`).children().appendTo(`#${id} .c-datepicker-picker__footer`);
    $(`#${id} .c-datepicker-picker__sidebar`).remove()
    let old = $(`#${id} .c-datepicker-picker__footer`).children()
    for(let i=0;i<old.length;i++){
        // old[i].className = 'c-datepicker-picker__shortcut my-button'
        let txt = old[i].innerHTML


        if(txt && txt.indexOf('清空') == -1) {
            old[i].className = 'c-datepicker-picker__shortcut my-button'
        }else{
            old[i].className = old[i].className + ' c-datepicker-picker__shortcut my-button'
        }

        if(txt && txt.indexOf('确定') > -1) old[i].remove()
        // if(txt && txt.indexOf('清空') > -1) old[i].remove()
    }

    $("#"+id).css({"display":"block"});

    $("body").one("click",function(){
        $("#"+id).css({"display":"none"});
    })
}

var DATAPICKERAPI = {
    // 快捷选项option,参数day是距离今天是天数
    rangeShortcutOption1: [{
        name: '今天',
        day: '0,0',
    }, {
        name: '昨天',
        day: '-1,-1',
    }, {
        name: '本月',
        day: '-'+(getDaysFromFirstDayOfMonth()-1)+','+ getDaysUntilLastDayOfMonth(),
    }, {
        name: '上月',
        day: '-'+ (getLastMonthToToday()-1) +',-' + getDaysFromFirstDayOfMonth(),
    }, {
        name: '本季度',
        day:'-' +(getDaysToLastDayOfPreviousQuarter() -2)+','+ calculateDays( getDaysToThisDayOfPreviousQuarter() ),
    }, {
        name: '上季度',
        day: calculateDays( getLastQuarterFirstDay() )  +', -' + (getDaysToLastDayOfPreviousQuarter()-1),
    }, {
        name: '当年',
        // day: '-'+ (lastYearLToToday()-1) +', '+ toDayToNextYear(),
        day: '-'+ (lastYearLToToday()-1) +', 0',
    }, {
        name: '去年',
        day:'-'+lastYearFToToday() + ', -'+lastYearLToToday(),
    }],
};

